<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Decl. Variable Definitions</TITLE>
<link href="builder_38.html" rel=Next>
<link href="builder_36.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_36.html">previous</A>, <A HREF="builder_38.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC68" HREF="builder_toc.html#TOC68">Defining Variables and Generating New Type Definitions</A></H2>
<P>
<A NAME="IDX630"></A>
<A NAME="IDX631"></A>

</P>


<H3><A NAME="SEC69" HREF="builder_toc.html#TOC69">Generating New Type Definitions</A></H3>
<P>
<A NAME="IDX632"></A>
The <CODE>parse_type</CODE> function parses a C-like type definition to create
the corresponding <CODE>type_node</CODE>. Existing type definitions can be
used to define the new type by including those definitions in the
function call. In the parsed string the token "%%" is replaced by the
next type definition from the argument list (just like printf).

</P>
<P>
<A NAME="IDX633"></A>
<A NAME="IDX634"></A>

<PRE>
     type_node * parse_type(char *, 
                            type_node * tn0=NULL, type_node * tn1=NULL,
                            type_node * tn2=NULL, type_node * tn3=NULL,
                            type_node * tn4=NULL, type_node * tn5=NULL,
                            type_node * tn6=NULL, type_node * tn7=NULL,
                            type_node * tn8=NULL, type_node * tn9=NULL)

     type_node * parse_type(base_symtab * st,
                            char *, 
                            type_node * tn0=NULL, type_node * tn1=NULL,
                            type_node * tn2=NULL, type_node * tn3=NULL,
                            type_node * tn4=NULL, type_node * tn5=NULL,
                            type_node * tn6=NULL, type_node * tn7=NULL,
                            type_node * tn8=NULL, type_node * tn9=NULL)
</PRE>

<P>
<A NAME="IDX635"></A>
<A NAME="IDX636"></A>
<A NAME="IDX637"></A>

</P>


<H3><A NAME="SEC70" HREF="builder_toc.html#TOC70">Defining Variables</A></H3>
<P>
<A NAME="IDX638"></A>
A new variable is created using a
<CODE>new_sym</CODE> function. The type of the variable is determined by
using either a <CODE>type_node</CODE>, <CODE>if_type</CODE>, or a
<CODE>const_type</CODE> (in <CODE>builder_internals.h</CODE>). If the optional name
field is not used, a unique name is assigned by the builder.

</P>
<P>
<A NAME="IDX639"></A>
<A NAME="IDX640"></A>

<PRE>
     block &#38; new_sym(const_type tp);
     block &#38; new_sym(const_type tp, 
                     char * nm)
     block &#38; new_sym(type_node * tp, 
                     char * nm)
     block &#38; new_sym(char * parse_tp, 
                     char * nm)

     sym_node * get_sym()

     block &#38; new_label(char *nm) 
     block &#38; new_label(label_sym *ls) 
</PRE>

<P>
<A NAME="IDX641"></A>
<A NAME="IDX642"></A>
<A NAME="IDX643"></A>
<A NAME="IDX644"></A>
<A NAME="IDX645"></A>
<A NAME="IDX646"></A>
<A NAME="IDX647"></A>
<A NAME="IDX648"></A>
<A NAME="IDX649"></A>
<A NAME="IDX650"></A>

</P>
<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_36.html">previous</A>, <A HREF="builder_38.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
